import random

import numpy as np
import segmentation_models_pytorch as smp
import torch.nn as nn
from torch.utils.data import DataLoader

from models.load_models import device
from models.unet_impl import UNet2
from train.train import train_for_epochs
from train.utils import MyDataset, MyDataset_test
from utils.constants import num_classes

poland_imgs = np.float32(
    (np.load('/path/to/train/data/Poland_images.npy')))
poland_masks = np.float32(
    (np.load('/path/to/train/data/Poland_masks.npy')))
hungary_imgs = np.float32(
    (np.load('/path/to/train/data/Hungary_images.npy')))
hungary_masks = np.float32(
    (np.load('/path/to/train/data/Hungary_masks.npy')))
train_masks1 = np.float32((np.load(
    '/path/to/train/data/SE_masks_sh_merged.npy')))
train_imgs = np.float32(
    (np.load('/path/to/train/data/SE_imgs.npy')))

test_imgs = np.float32(
    (np.load('/path/to/train/data/new_test_for_masks.npy')))
test_masks1 = np.float32((np.load(
    '/path/to/train/data/SE_test_masks_sh_merged.npy')))
test_imgs = np.append(test_imgs, np.float32((np.load(
    '/path/to/train/data/Vilskerst_selected_images.npy'))), axis=0)
test_masks1 = np.append(test_masks1, np.float32((np.load(
    '/path/to/train/data/Vilskerst_selected_masks_sh_merged.npy'))), axis=0)
test_imgs = np.append(test_imgs, np.float32((np.load(
    '/path/to/train/data/Hausenloy_images.npy'))), axis=0)
test_masks1 = np.append(test_masks1, np.float32((np.load(
    '/path/to/train/data/Hausenloy_selected_masks_sh_merged.npy'))), axis=0)
test_imgs = np.append(test_imgs, np.float32((np.load(
    '/path/to/train/data/Sauri_rat_images.npy'))), axis=0)
test_masks1 = np.append(test_masks1, np.float32((np.load(
    '/path/to/train/data/Sauri_rat_masks_sh_merged.npy'))), axis=0)

train_indeces = []
for t in range(int(float(poland_imgs.shape[0]+hungary_imgs.shape[0])/2.0)):
    rand_num = random.randint(0, train_imgs.shape[0]-1)
    while rand_num in train_indeces:
        rand_num = random.randint(0, train_imgs.shape[0]-1)
    train_indeces.append(rand_num)

train_imgs = train_imgs[train_indeces, :, :, :]
train_masks1 = train_masks1[train_indeces, :, :, :]
train_imgs = np.append(train_imgs, poland_imgs, axis=0)
train_imgs = np.append(train_imgs, hungary_imgs, axis=0)
train_masks1 = np.append(train_masks1, poland_masks, axis=0)
train_masks1 = np.append(train_masks1, hungary_masks, axis=0)

train_set1 = MyDataset(train_imgs, train_masks1)
test_set1 = MyDataset_test(test_imgs, test_masks1)

train_loader_batch8 = DataLoader(dataset=train_set1,
                                 batch_size=16, shuffle=True)
test_loader1 = DataLoader(dataset=test_set1,
                          batch_size=8, shuffle=True)

Net1 = UNet2(3, num_classes).to(device)
Net2 = smp.UnetPlusPlus(encoder_name='resnet34', encoder_weights='imagenet',
                        classes=num_classes).to(device)
Net3 = smp.DeepLabV3Plus(encoder_name='resnet34', encoder_weights='imagenet',
                         classes=num_classes).to(device)

name = "test"
print("Traning Net1")
Net1 = train_for_epochs(Net1, train_loader_batch8, test_loader1,
                        nn.BCEWithLogitsLoss(), "ownUNet_" + name + ".pt", 50, 0.0)
print("Traning Net2")
Net2 = train_for_epochs(Net2, train_loader_batch8, test_loader1,
                        nn.BCEWithLogitsLoss(), "unet++_" + name + ".pt", 50, 0.0)
print("Traning Net3")
Net3 = train_for_epochs(Net3, train_loader_batch8, test_loader1,
                        nn.BCEWithLogitsLoss(), "deeplabv3+_" + name + ".pt", 50, 0.0)
