
import json
import os

# Constants
# Read config file
try:
    config = open("config.json", "r")
    config = json.load(config)
    print("Config file loaded")
except:
    print("Config file not found")
    config = {}

# UPLOAD_FOLDER stores the images while they are being processed
os.makedirs('./upload', exist_ok=True)
UPLOAD_FOLDER = './upload'
# ALLOWED_EXTENSIONS is a set of allowed file extensions for the uploaded images
ALLOWED_EXTENSIONS = {'png', 'jpg', 'jpeg'}
# Path to your model
if config != {}:
    model_unet_impl = config['model_unet_impl']
    model_smp_unet = config['model_smp_unet']
    model_smp_deeplab = config['model_smp_deeplab']
    port = config['port']
    debug = config['debug']
else:
    model_unet_impl = "./models/random_net1.pt"
    model_smp_unet = './models/random_net2.pt'
    model_smp_deeplab = './models/random_net3.pt'
    port = 5000
    debug = False
# Set the supported classes
num_classes = 3
